import { IEvent, IEventPublisher, IMessageSource } from '@nestjs/cqrs';
import { Subject } from 'rxjs';
import { EventStoreOptionConfig } from './event-store-option.config';
import { IEventStoreConnectConfig } from './contract/event-store-connect-config.interface';
export declare class EventStore implements IEventPublisher, IMessageSource {
    private eventStore;
    private eventHandlers;
    private readonly category;
    private readonly eventStoreHostUrl;
    private readonly resolveLinkTos;
    constructor(eventStore: any, configService: IEventStoreConnectConfig, esStreamConfig: EventStoreOptionConfig);
    publish<T extends IEvent>(event: T): Promise<void>;
    bridgeEventsTo<T extends IEvent>(subject: Subject<T>): Promise<void>;
    setEventHandlers(eventHandlers: any): void;
}
